	.file	"ttstart.c"
gcc2_compiled.:
__gnu_compiled_c:
#APP
	move.l 0xC8,%a5
	
	bset #7,(%sp)              /* The support for ~exit~ and ~atexit~   */
	jmp _main                  /* and the workaround for a bug in TIGCC */
	
#NO_APP
.globl _tt_InBuffer
.data
	.even
_tt_InBuffer:
	.long 0
.globl _tt_InMask
	.even
_tt_InMask:
	.word 0
#APP
	
.globl _tt_Get8Bit
_tt_Get8Bit:
    lea     _tt_InBuffer,%a0
    movea.l (%a0),%a1           /* address of current byte */
    clr.w   %d0
    move.b  (%a1)+,%d0          /* anyway, read first byte */
    move.l  %a1,(%a0)           /* and increment pointer */
    move.w  _tt_InMask,%d1
    cmpi.b  #0x80,%d1
    bne.s   __inl_tries
    rts
__inl_tries:
    lsl.w   #8,%d0              /* v = *(_tt_InBuffer++) << 8; */
    move.b  (%a1),%d0           /* v |= *_tt_InBuffer; */
    /* bra.s    try08 */
    cmpi.b  #0x08,%d1
    bhi.s   __inl_try20
    bne.s   __inl_try02
    andi.w  #0x0fff,%d0
    lsr.w   #4,%d0
    rts
__inl_try40:
    andi.w  #0x7fff,%d0
    lsr.w   #7,%d0
    rts
__inl_try20:
    cmpi.b  #0x20,%d1
    bhi.s   __inl_try40
    bcs.s   __inl_try10
    andi.w  #0x3fff,%d0
    lsr.w   #6,%d0
    rts
__inl_try10:
    andi.w  #0x1fff,%d0
    lsr.w   #5,%d0
    rts
__inl_try04:
    andi.w  #0x07ff,%d0
    lsr.w   #3,%d0
    rts
__inl_try02:
    cmpi.b  #0x02,%d1
    bhi.s   __inl_try04
    bne.s   __inl_try01
    andi.w  #0x03ff,%d0
    lsr.w   #2,%d0
    rts
__inl_try01:
    andi.w  #0x01ff,%d0
    lsr.w   #1,%d0
    rts

	
.globl _tt_GetValue
_tt_GetValue:
    move.l  %d3,-(%sp)
    clr.l   %d1                 /* i */
    move.w  8(%sp),%d0          /* maxgamma */
    move.l  _tt_InBuffer,%a0
    move.w  _tt_InMask,%d2

__inl_loop1:
    cmp.w   %d1,%d0
    bls.s   __inl_exitloop
    /* !(*_tt_InBuffer & _tt_InMask) */
    move.w  %d2,%d3
    and.b   (%a0),%d3
    /* if (!(_tt_InMask >>= 1)) _tt_InMask = 0x80,_tt_InBuffer++; */
    ror.b   #1,%d2          /* thx tom for the ror with carry trick ;) */
    bcc.s   __inl_samebyte1
    addq.l  #1,%a0
__inl_samebyte1:
    /* test if next bit set only now */
    tst.b   %d3
    beq.s   __inl_exitloop
    addq.w  #1,%d1
    bra.s   __inl_loop1
__inl_exitloop:
    move.l  %a0,_tt_InBuffer
    move.w  %d2,_tt_InMask
    moveq   #1,%d3
    lsl.w   %d1,%d3
    move.w  %d1,-(%sp)
    bsr.s       _tt_GetBits
    addq    #2,%sp
    or.w    %d3,%d0
    move.l  (%sp)+,%d3
    rts

	
.globl _tt_GetBits
_tt_GetBits:
    clr.w   %d0
    move.w  4(%sp),%d1
    beq.s   __inl_exit          /* just in case ;) */
    movea.l _tt_InBuffer,%a0    /* _tt_InBuffer, gcc makes it pc relative :) */
    movea.l %d3,%a1             /* use a1 to save d3: 4 cycles better than move.w %d3,-(%sp) */
    move.w  _tt_InMask,%d2      /* pc relative too :)) */
    subq.w  #1,%d1

__inl_loop0:
    lsl.w   #1, %d0
    /* (*_tt_InBuffer & _tt_InMask) */
    move.w  %d2,%d3
    and.b   (%a0),%d3
    beq.s   __inl_correct0
    addq.b  #1,%d0          /* here, bit #0 of %d0 is never set :) it's a four cycles gain :)) */
__inl_correct0:
    /* if (!(_tt_InMask >>= 1)) _tt_InMask = 0x80,_tt_InBuffer++; */
    ror.b   #1,%d2
    bcc.s   __inl_samebyte0
    addq.l  #1,%a0
__inl_samebyte0:
    dbra    %d1,__inl_loop0

    move.w  %d2,_tt_InMask      /* saves _tt_InMask */
    move.l  %a1,%d3             /* restores d3 (4 cycles again :) */
    move.l  %a0,_tt_InBuffer    /* saves _tt_InBuffer */
__inl_exit:
    rts

#NO_APP
.text
	.even
.globl _tt_Decompress
_tt_Decompress:
	link.w %a6,#-16
	movm.l #0x1f38,-(%sp)
	move.l 8(%a6),%a0
	cmp.b #84,2(%a0)
	jbne .L4
	cmp.b #80,3(%a0)
	jbeq .L3
.L4:
	move.w #252,%d0
	jbra .L38
	.even
.L3:
	clr.l %d6
	move.b 6(%a0),%d6
	clr.w %d7
	move.b 9(%a0),%d7
	clr.w %d5
	move.b 10(%a0),%d5
	subq.w #1,%d5
	clr.w %d0
	move.b 12(%a0),%d0
	move.w %d0,-12(%a6)
	moveq.l #1,%d1
	lsl.w %d5,%d1
	move.w %d1,-6(%a6)
	moveq.l #2,%d0
	lsl.w %d5,%d0
	move.w %d0,-8(%a6)
	moveq.l #8,%d1
	sub.w %d5,%d1
	move.w %d1,-10(%a6)
	moveq.l #8,%d0
	sub.w %d7,%d0
	move.w %d0,%a4
	move.w #249,%d0
	cmp.w #8,%d7
	jbhi .L38
	clr.w %d0
	move.b 11(%a0),%d0
	cmp.w -6(%a6),%d0
	jbne .L7
	cmp.w #4,%d5
	jbls .L7
	cmp.w #7,%d5
	jbls .L6
.L7:
	move.w #250,%d0
	jbra .L38
	.even
.L6:
	cmp.w #4,-12(%a6)
	jbls .L8
	move.w #251,%d0
	jbra .L38
	.even
.L8:
	lea (15,%a0),%a1
	move.l %a1,-4(%a6)
	move.l 12(%a6),%a3
	clr.l %d0
	move.b (%a1),%d0
	lea 16(%a0,%d0.l),%a0
	move.l %a0,_tt_InBuffer
	move.w #128,_tt_InMask
	.even
.L11:
	move.w %d6,%d3
	tst.w %d7
	jbeq .L12
	move.w %d7,-(%sp)
	jsr _tt_GetBits
	move.w %d0,%d3
	addq.l #2,%sp
.L12:
	move.w %d3,%a0
	cmp.l %a0,%d6
	jbne .L13
	move.w %d5,-(%sp)
	lea _tt_GetValue,%a2
	jsr (%a2)
	move.w %d0,%d4
	clr.w -14(%a6)
	addq.l #2,%sp
	cmp.w #1,%d4
	jbeq .L14
	move.w %d5,-(%sp)
	jsr (%a2)
	move.w %d0,%d3
	subq.w #1,%d3
	move.w -8(%a6),%d0
	subq.w #2,%d0
	addq.l #2,%sp
	cmp.w %d3,%d0
	jbne .L15
	cmp.w #3,%d4
	jbls .L10
	lea _tt_Get8Bit,%a2
	jsr (%a2)
	move.w %d0,-14(%a6)
	jsr (%a2)
	jbra .L39
	.even
.L15:
	tst.w -12(%a6)
	jbeq .L19
	move.w -12(%a6),-(%sp)
	jsr _tt_GetBits
	move.w -12(%a6),%d1
	lsl.w %d1,%d3
	or.w %d0,%d3
	addq.l #2,%sp
.L19:
	jsr _tt_Get8Bit
	eor.w #255,%d0
	move.w %d3,%d1
	lsl.w #8,%d1
	or.w %d0,%d1
	jbra .L20
	.even
.L14:
	move.l _tt_InBuffer,%a0
	clr.w %d0
	move.b (%a0),%d0
	move.w _tt_InMask,%d1
	and.w %d1,%d0
	jbeq .L21
#APP
	ror.b  #1,%d1
	bcc.s  __inl_tt_cim_skip0
	addq.l #1,_tt_InBuffer
__inl_tt_cim_skip0:
#NO_APP
	move.w %d1,_tt_InMask
	move.l _tt_InBuffer,%a0
	clr.w %d0
	move.b (%a0),%d0
	and.w %d1,%d0
	jbne .L22
	move.w %d1,%d0
#APP
	ror.b  #1,%d0
	bcc.s  __inl_tt_cim_skip1
	addq.l #1,_tt_InBuffer
__inl_tt_cim_skip1:
#NO_APP
	move.w %d0,_tt_InMask
	move.w %d7,-(%sp)
	lea _tt_GetBits,%a2
	jsr (%a2)
	move.w %d0,%d3
	move.w %a4,-(%sp)
	jsr (%a2)
	move.w %a4,%d1
	ext.l %d1
	lsl.l %d1,%d6
	or.b %d0,%d6
	move.b %d6,(%a3)+
	clr.l %d6
	move.w %d3,%d6
	addq.l #4,%sp
	jbra .L11
	.even
.L22:
	move.w %d1,%d0
#APP
	ror.b  #1,%d0
	bcc.s  __inl_tt_cim_skip2
	addq.l #1,_tt_InBuffer
__inl_tt_cim_skip2:
#NO_APP
	move.w %d0,_tt_InMask
	move.w %d5,-(%sp)
	jsr (%a2)
	move.w %d0,%d3
	addq.l #2,%sp
	cmp.w -6(%a6),%d3
	jbcs .L23
	move.w -10(%a6),-(%sp)
	jsr _tt_GetBits
	sub.w -6(%a6),%d3
	move.w -10(%a6),%d1
	lsl.w %d1,%d3
	or.w %d0,%d3
	move.w %d5,-(%sp)
	jsr (%a2)
	subq.w #1,%d0
	lsl.w #8,%d0
	or.w %d0,%d3
	addq.l #4,%sp
.L23:
	move.w %d5,-(%sp)
	jsr (%a2)
	move.w %d0,%d4
	addq.l #2,%sp
	cmp.w #31,%d4
	jbhi .L24
	clr.l %d0
	move.w %d4,%d0
	move.l -4(%a6),%a0
	move.b (%a0,%d0.l),%d1
	ext.w %d1
	jbra .L25
	.even
.L24:
	move.w #3,-(%sp)
	jsr _tt_GetBits
	move.w %d4,%d1
	add.w #-32,%d1
	lsl.w #3,%d1
	or.w %d0,%d1
	addq.l #2,%sp
.L25:
	clr.w %d2
	cmp.w %d2,%d3
	jbcs .L11
	.even
.L29:
	move.b %d1,(%a3)+
	addq.w #1,%d2
	cmp.w %d2,%d3
	jbcc .L29
	jbra .L11
	.even
.L21:
	move.w %d1,%d0
#APP
	ror.b  #1,%d0
	bcc.s  __inl_tt_cim_skip3
	addq.l #1,_tt_InBuffer
__inl_tt_cim_skip3:
#NO_APP
	move.w %d0,_tt_InMask
	jsr _tt_Get8Bit
.L39:
	move.w %d0,%d1
	eor.w #255,%d1
.L20:
	clr.w %d2
	cmp.w %d2,%d4
	jbcs .L11
	.even
.L34:
	clr.l %d0
	move.w %d1,%d0
	move.l %a3,%a0
	sub.l %d0,%a0
	move.b -13(%a6),%d0
	add.b -1(%a0),%d0
	move.b %d0,(%a3)+
	addq.w #1,%d2
	cmp.w %d2,%d4
	jbcc .L34
	jbra .L11
	.even
.L13:
	move.w %a4,-(%sp)
	jsr _tt_GetBits
	move.w %a4,%d1
	lsl.w %d1,%d3
	or.b %d0,%d3
	move.b %d3,(%a3)+
	addq.l #2,%sp
	jbra .L11
	.even
.L10:
	clr.w %d0
.L38:
	movm.l -48(%a6),#0x1cf8
	unlk %a6
	rts
.LC0:
	.ascii "tempprog\0"
.LC1:
	.ascii "%s not found\0"
.LC2:
	.ascii "locking failed\0"
.LC3:
	.ascii "no ppg file\0"
.LC4:
	.ascii "out of memory\0"
.LC5:
	.ascii "decompressing ...\0"
.LC6:
	.ascii "failed\0"
	.even
.LC7:
	.word 8312
	.word 200
	.word 3240
	.word 0
	.word 1000
	.word -4
	.word 25954
	.word 18663
	.word -2
	.word 20463
	.word -20
	.word 9852
	.word 3
	.word -8192
	.word 16147
	.word 12075
	.word 2
	.word 8200
	.word 640
	.word 96
	.word 0
	.word 1664
	.word 2
	.word 0
	.word 12096
	.word 12
	.word 12096
	.word 16
	.word 20044
	.word 18172
	.word 9984
	.word 30223
	.word 12043
	.word 16999
	.word 16890
	.word 22
	.word -11780
	.word 4
	.word 0
	.word 14012
	.word 20217
	.word 10056
	.word 2
	.word 8312
	.word 172
	.word 20176
	.word 9183
	.word 3
	.word -8190
	.word 13279
	.word 3
	.word -8192
	.word 20463
	.word 20
	.word 19679
	.word 32767
	.word 8287
	.word -11780
	.word 4
	.word 0
	.word 20176
	.even
.globl _main
_main:
	link.w %a6,#-52
	movm.l #0x1030,-(%sp)
	lea .LC0,%a3
	clr.b -50(%a6)
	move.l %a3,-(%sp)
	lea (-50,%a6),%a2
	pea -49(%a6)
	move.l 2480(%a5),%a0
	jsr (%a0)
	move.l %a3,-(%sp)
	move.l 2552(%a5),%a0
	jsr (%a0)
	pea 1(%a2,%d0.l)
	move.l 384(%a5),%a0
	jsr (%a0)
	move.l %d0,-(%sp)
	move.l 484(%a5),%a0
	jsr (%a0)
	lea (20,%sp),%sp
	cmp.w #0,%a0
	jbne .L41
	move.l %a3,-(%sp)
	pea .LC1
	move.l %a2,-(%sp)
	move.l 332(%a5),%a0
	jsr (%a0)
	move.l %a2,-(%sp)
	jbra .L53
	.even
.L41:
	move.w 12(%a0),-52(%a6)
	move.w -52(%a6),-(%sp)
	move.l 620(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
	tst.w %d0
	jbeq .L42
	move.w -52(%a6),-(%sp)
	move.l 600(%a5),%a0
	jsr (%a0)
	move.l %a0,%a2
	move.w #0,-52(%a6)
	jbra .L54
	.even
.L42:
	move.w -52(%a6),-(%sp)
	move.l 612(%a5),%a0
	jsr (%a0)
	move.l %a0,%a2
.L54:
	addq.l #2,%sp
	cmp.w #0,%a2
	jbne .L44
	pea .LC2
	jbra .L53
	.even
.L44:
	move.w (%a2),%d0
	addq.w #3,%d0
	and.l #0xFFFF,%d0
	lea -2(%a2,%d0.l),%a3
	addq.l #2,%a2
	cmp.b #248,(%a3)
	jbne .L46
	cmp.b #112,-4(%a3)
	jbne .L46
	cmp.b #112,-3(%a3)
	jbne .L46
	cmp.b #103,-2(%a3)
	jbne .L46
	cmp.b #84,2(%a2)
	jbne .L46
	cmp.b #80,3(%a2)
	jbeq .L45
.L46:
	move.w -52(%a6),%d0
	jbeq .L47
	move.w -52(%a6),-(%sp)
	move.l 636(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
.L47:
	pea .LC3
	jbra .L53
	.even
.L45:
	clr.w %d0
	move.b (%a2),%d0
	move.b 1(%a2),%d1
	lsl.w #8,%d1
	or.w %d1,%d0
	clr.l %d3
	move.w %d0,%d3
	move.l %d3,-(%sp)
	move.l 648(%a5),%a0
	jsr (%a0)
	move.l %a0,%a3
	addq.l #4,%sp
	cmp.w #0,%a3
	jbne .L48
	move.w -52(%a6),%d0
	jbeq .L49
	move.w -52(%a6),-(%sp)
	move.l 636(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
.L49:
	pea .LC4
	jbra .L53
	.even
.L48:
	pea .LC5
	move.l 920(%a5),%a0
	jsr (%a0)
	move.l %a3,-(%sp)
	move.l %a2,-(%sp)
	jsr _tt_Decompress
	lea (12,%sp),%sp
	tst.w %d0
	jbeq .L50
	move.l %a3,-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
	addq.l #4,%sp
	move.w -52(%a6),%d0
	jbeq .L51
	move.w -52(%a6),-(%sp)
	move.l 636(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
.L51:
	pea .LC6
.L53:
	move.l 920(%a5),%a0
	jsr (%a0)
	jbra .L40
	.even
.L50:
	move.l 908(%a5),%a0
	jsr (%a0)
	move.w -52(%a6),%d0
	jbeq .L52
	move.w -52(%a6),-(%sp)
	move.l 636(%a5),%a0
	jsr (%a0)
	addq.l #2,%sp
.L52:
	jsr .LC7
	pea -1(%a3,%d3.l)
	move.l #262146,%a2
	add.l %a3,%a2
	move.l %a2,-(%sp)
	move.l 1384(%a5),%a0
	jsr (%a0)
	addq.l #8,%sp
#APP
	movem.l %d0-%d7/%a0-%a6,-(%sp)
#NO_APP
	jsr (%a2)
#APP
	nop;nop;nop;nop;
	movem.l (%sp)+,%d0-%d7/%a0-%a6
#NO_APP
	move.l %a3,-(%sp)
	move.l 652(%a5),%a0
	jsr (%a0)
.L40:
	movm.l -64(%a6),#0xc08
	unlk %a6
	rts
.comm _ti92plus,2
.comm _ti89,2
.comm _nostub,2
